//
//  main.c
//  h2mcs
//
//  Created by Alexander von Zitzewitz on 9/8/14.
//  Copyright (c) 2014 hello2morrow GmbH. All rights reserved.
//

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifdef _MSC_VER
#include <process.h>
#else
#include <unistd.h>
#endif

#define BUFFER_SIZE 128*1024
#define CATURE_FILE_NAME "h2m-capture.txt"

static int endsWith(const char *str, const char *suffix)
{
    if (!str || !suffix)
    {
        return 0;
    }
    size_t lenstr = strlen(str);
    size_t lensuffix = strlen(suffix);
    if (lensuffix >  lenstr)
    {
        return 0;
    }
    return strncmp(str + lenstr - lensuffix, suffix, lensuffix) == 0;
}

int main(int argc, const char * argv[])
{
    if (argc == 2 && strcmp(argv[1], "clean") == 0)
    {
        return system("find . -name " CATURE_FILE_NAME " -type f -delete");
    }
    if (argc <= 2)
    {
        fprintf(stderr, "h2mcs: missing arguments\n");
        return 1;
    }
    if (strcmp("-c", argv[1]) != 0 && strcmp("/c", argv[1]) != 0)
    {
        fprintf(stderr, "h2mcs: unexpected arguments\n");
        return 1;
    }
    
    char *buffer = malloc(BUFFER_SIZE);
    int i, pos = 0;
    int hasMinusC = 0;
    
    for (i = 2; i < argc; i++)
    {
        if (i > 2)
        {
            buffer[pos++] = ' ';
        }
        strcpy(buffer+pos, argv[i]);
        pos += strlen(argv[i]);
        if (strstr(argv[i], " -c ") != NULL || strstr(argv[i], " /c ") != NULL)
        {
            hasMinusC++;
        }
    }
    if (hasMinusC > 0)
    {
        //Only append to capture file, if "-c" is present (probably a compile command)
        FILE *captureFile = fopen(CATURE_FILE_NAME, "a");
    
        if (captureFile == NULL)
        {
            getcwd(buffer, BUFFER_SIZE);
            fprintf(stderr, "h2mcs: could not open or write to '%s/%s'\n", buffer, CATURE_FILE_NAME);
            return 1;
        }
        fprintf(captureFile, "%s\n", buffer);
        fclose(captureFile);
    }
    if (endsWith(argv[2], "make"))
    {
        sprintf(buffer+pos, " SHELL=%s", argv[0]);
    }
    return system(buffer);
}

